<?php

/**
 *  Order Master
 * :  
 * http://ordermaster.ru/
 *
 *  :   
 *    2.0
 *
 * @ 1.07.2014
 */

if (!defined('BASEPATH')) exit('No direct script access allowed');

class Ps extends Controller {
	
	function Ps () {
		parent::Controller ();		
	}
	
	/**
 	*      
 	*/
 	function _models () {
 		if (empty ($_POST)) {
			die ('Error:   ');
		}
		$this->load->model ('mdl_goods');
		$this->load->model ('mdl_bills');
	}	
	
	/**
 	*   WebMoney 
 	*/
 	function webmoney () {
	
		$this->_models();
		
		if ($this->config->item ('om_webmoney_on') !=1 ) {
			die ('Error:  ');			
		}
		
		extract ($_POST,EXTR_SKIP);
	
	    $zpurse = $this->config->item ('om_wmz');
	    $rpurse = $this->config->item ('om_wmr');
	    $testMode = 0; //  
	    
	    $wmkey = $this->config->item ('om_wmkey');	    
		
		
		if (empty ($LMI_HASH)) {
			die ('Error:   ');
		}
		
		if (strpos (strtoupper ($LMI_PAYEE_PURSE),'Z')!==false) {			
			$type = 'usd';			
		} 
		else {
			$type = 'rur';
		}
		
		if ($type == 'usd') {

	     $str = "{$zpurse}{$LMI_PAYMENT_AMOUNT}{$LMI_PAYMENT_NO}{$testMode}{$LMI_SYS_INVS_NO}";
    	 $str .="{$LMI_SYS_TRANS_NO}{$LMI_SYS_TRANS_DATE}{$wmkey}{$LMI_PAYER_PURSE}{$LMI_PAYER_WM}";
			
		}
		else {
			
 	     $str = "{$rpurse}{$LMI_PAYMENT_AMOUNT}{$LMI_PAYMENT_NO}{$testMode}{$LMI_SYS_INVS_NO}";
     	 $str .="{$LMI_SYS_TRANS_NO}{$LMI_SYS_TRANS_DATE}{$wmkey}{$LMI_PAYER_PURSE}{$LMI_PAYER_WM}";
			
		}
		
	    $LMI_HASH = strtolower ($LMI_HASH);

	    if (($LMI_HASH===md5 ($str)) OR ($LMI_HASH===hash('sha256', ($str))))
	    {
	    	$bill_id = $LMI_PAYMENT_NO;
	    	$sum = $LMI_PAYMENT_AMOUNT;
	    	
	    	$way = ($type == 'usd') ? 'WebMoney Z':'WebMoney R';
	    	
    	    $this->mdl_bills->result_url($bill_id,$way,$sum,$type);	    	
	    }
		else {
			die ('Error:   ');
		}
		
						
	}
	
	function rupay () {
		$this->rbkmoney();
	}	
	
	/**
 	*   RBKMoney 
 	*/
 	function rbkmoney () {
	
		$this->_models();
		
		if ($this->config->item ('om_rbkmoney_on') !=1 ) {
			die ('Error:  ');			
		}
	
		extract ($_POST,EXTR_SKIP);
	
	    $rbkmoneyid = $this->config->item ('om_rbkmoney_id');
	    
	    $rbkmoneykey = $this->config->item ('om_rbkmoney_key');
		
		if (empty ($hash)) {
			die ('Error:   ');
		}
		
	    	$str = "$rbkmoneyid::$orderId::$serviceName::$eshopAccount::$recipientAmount";
    		$str .= "::RUR::5::$userName::$userEmail::$paymentData::$rbkmoneykey";			
		
	    $crc = strtolower ($hash);

        if ($crc===md5 ($str))
	    {
	    	$bill_id = $orderId;
	    	$sum = $recipientAmount;
	    	
	    	$way = 'RBKMoney';
	    	
    	    $this->mdl_bills->result_url($bill_id,$way,$sum);
			
			header("http/1.0 200 Ok");
			echo 'OK';
				    	
	    }
		else {
			die ('Error:   ');
		}
						
	}
	
	/**
 	*    2.0
 	*/
 	function inter () {
	
		$this->_models();
		
		if ($this->config->item ('om_interkassa_on') !=1 ) {
			die ('Error:  ');			
		}
	
		extract ($_POST,EXTR_SKIP);
        
		
	    $interkassaid = $this->config->item ('om_interkassa_id');
	    
	    $interkassakey = $this->config->item ('om_interkassa_key');
        
            
            if (isset ($ik_sign)) {
                
                //                 
                
                
                $ss = $_POST;
                unset ($ss['ik_sign']);                
                
                ksort ($ss, SORT_STRING);
                array_push ($ss,$interkassakey);
                $signstr = implode (':',$ss);                
                $str = base64_encode (md5 ($signstr,true));
                		
                $crc = $ik_sign;	    
                
                

            if ($crc===$str)
                {
                    if ($ik_inv_st == 'success') {
        	    	$bill_id = $ik_pm_no;
                	$sum = $ik_am;
	    	
                	$way = '';
	    	
                    $this->mdl_bills->result_url($bill_id,$way,$sum,'usd');
                    }
                }
                else {
                    die ('Error:   ');
                }
                
                
                
            }
            
            
		
		if (empty ($ik_sign_hash)) {
			die ('Error:   ');
		}
		
	    	$str = "$interkassaid:$ik_payment_amount:$ik_payment_id:$ik_paysystem_alias:$ik_baggage_fields";
    		$str .= ":success:$ik_trans_id:$ik_currency_exch:$ik_fees_payer:$interkassakey";			
		
	    $crc = strtolower ($ik_sign_hash);	    

        if ($crc===md5 ($str))
	    {
	    	$bill_id = $ik_payment_id;
	    	$sum = $ik_payment_amount;
	    	
	    	$way = '';
	    	
    	       $this->mdl_bills->result_url($bill_id,$way,$sum,'usd');
            }
            else {
                    die ('Error:   ');
            }




						
	}	
	
		
	
	/**
 	*   Robox 
 	*/
 	function robox () {
	
		$this->_models();
		
		if ($this->config->item ('om_robox_on') !=1 ) {
			die ('Error:  ');			
		}
		
		extract ($_POST,EXTR_SKIP);		
	
	    $roboxpass2 = $this->config->item ('om_robox_pass2');
	    
		
		if (empty ($crc)) {
			die ('Error:   ');
		}
		
	    	$str = "$out_summ:$inv_id:$roboxpass2";
			
        if (!is_numeric ($inv_id)) {
            die ('Bad number');                                    
        }						
		
	    $crc = strtolower ($crc);

        if ($crc===md5 ($str))
	    {
	    	$bill_id = $inv_id-100000;
	    	$sum = $out_summ;
	    	
	    	$way = '';
	    	
    	    $this->mdl_bills->result_url($bill_id,$way,$sum,config_item ('om_robox_valuta'));
			die ("OK$inv_id\n");	    	
	    }
		else {
			die ('Error:   ');
		}
						
	}	
	






	/**
 	*   Z-Payment 
 	*/
 	function zpay () {
	
		$this->_models();
		
		if ($this->config->item ('om_zpay_on') !=1 ) {
			die ('Error:  ');			
		}
		
		extract ($_POST,EXTR_SKIP);
	
	    $zpayid = $this->config->item ('om_zpay_id');
	    
	    $zpkey = $this->config->item ('om_zpay_key');	    
		
		
		if (empty ($LMI_HASH)) {
			die ('Error:   ');
		}
		
		
    	$str = "{$zpayid}{$LMI_PAYMENT_AMOUNT}{$LMI_PAYMENT_NO}0{$LMI_SYS_INVS_NO}".
        	   "{$LMI_SYS_TRANS_NO}{$LMI_SYS_TRANS_DATE}{$zpkey}{$LMI_PAYER_PURSE}{$LMI_PAYER_WM}";
		
	    $LMI_HASH = strtolower ($LMI_HASH);

	    if ($LMI_HASH===md5 ($str))
	    {
	    	$bill_id = $LMI_PAYMENT_NO;
	    	$sum = $LMI_PAYMENT_AMOUNT;
	    	
	    	$way = 'Z-Payment';
	    	
    	    $this->mdl_bills->result_url($bill_id,$way,$sum,'rur');	    	
	    }
		else {
			die ('Error:   ');
		}
						
	}



	/**
 	*   2checkout 
 	*/
 	function checkout () {
		
		
		$this->_models();
		
		if ($this->config->item ('om_checkout_on') !=1 ) {
			die ('Error:  ');			
		}
	
		extract ($_POST,EXTR_SKIP);
		
	
	    $coid = $this->config->item ('om_checkout_id');
	    
	    $seckey = $this->config->item ('om_checkout_key');
		
		if (empty ($key)) {
			die ('Error:   ');
		}
		
		$ornum = $order_number;
		
		if ($demo == 'Y' || ($ornum == 1)) {
			die ('  ');
		}
		
		$str = "{$seckey}{$coid}{$ornum}{$total}";			
		
	    $crc = strtolower ($key);

        if ($crc===md5 ($str))
	    {
	        if (!is_numeric ($order_number)) {
    	        die ('Order id must be numeric!');
       		}
       		
	        if (!is_numeric ($cart_id)) {
    	        die ('Cart id must be numeric!');
        	}
        	$bill_id = $merchant_order_id-1000;
	    	
	    	//  	    		 
	        if ($credit_card_processed == 'Y') 
    		    {
    	    	
    	    	//    2Checkout
    	    	$ocheck = substr ($ornum,5,6);
    	    	
    	    	$this->db->where ('checkout_id',$ocheck);
    	    	if ($this->db->count_all_results('checkouts')==0) {
					$this->db->insert('checkouts', array ('checkout_id' => $ocheck));
				}
				else {
					die ('   ,   e-mail.      -    ');
				}
    	    	
		    	
		    	$sum = $total;
		    	
		    	$way = '2CheckOut';
		    	
	    	    $this->mdl_bills->result_url($bill_id,$way,$sum,'usd');
	    	    
	    	    redirect ('ps/checkout_ok');
			}	
			//            	
			else {
				
				$this->pay_error($bill_id,'    2CheckOut,        2CheckOut');
				redirect ('ps/checkout_wait');
			}
	    }
		else {
			die ('Error:   ');
		}
		
		
	}




	/**
 	*   SMSCoin 
 	*/
 	function sms () {
	
		$this->_models();
		
		if ($this->config->item ('om_sms_on') !=1 ) {
			die ('Error:  ');			
		}
	
		extract ($_POST,EXTR_SKIP);
	
	    $smsid = $this->config->item ('om_sms_id');
	    
	    $smskey = $this->config->item ('om_sms_key');
		
		if (empty ($s_sign_v2)) {
			die ('Error:   ');
		}
		
	    $str = "$smskey::$smsid::$s_order_id::$s_amount::$s_clear_amount::$s_inv::$s_phone";
				
	    $crc = strtolower ($s_sign_v2);

        if ($crc===md5 ($str))
	    {
	    	$bill_id = $s_order_id;
	    	$sum = $s_amount;
	    	
	    	$way = 'SMSCoin';
	    	
    	    $this->mdl_bills->result_url($bill_id,$way,$sum,'usd');	    	
	    }
		else {
			die ('Error:   ');
		}
						
	}

	
	 
	
	/**
 	*   ,       
 	*/
 	function nalozh_send () {
		$this->lib_view->show ('nalozh_send','     ');
	}
	
	function _ok ($way) {
		$this->lib_view->show ($way.'_ok','',array(),'ok');
	}
	
	function _fail ($way) {
		$this->lib_view->show ($way.'_fail','  ',array(),'fail');
	}
	
	/**
 	* WebMoney Ok 
 	*/
 	function webmoney_ok () {
		$this->_ok ('webmoney');
	}
	
	/**
 	* WebMoney Fail 
 	*/
 	function webmoney_fail () {
		$this->_fail ('webmoney');
	}
	
	/**
 	* RBKMoney Ok 
 	*/
 	function rbkmoney_ok () {
		$this->_ok ('rbkmoney');
	}
	
	function rbkmoney_fail () {
		$this->_fail('rbkmoney');
	}
 	function rupay_ok () {
		$this->_ok ('rbkmoney');
	}
	
	function rupay_fail () {
		$this->_fail('rbkmoney');
	}

	
 	function interkassa_ok () {
		$this->_ok ('interkassa');
	}
	
	function interkassa_fail () {
		$this->_fail('interkassa');
	}	
	

 	function robox_ok () {
		$this->_ok ('robox');
	}
	
	function robox_fail () {
		$this->_fail('robox');
	}


 	function zpay_ok () {
		$this->_ok ('zpay');
	}
	
	function zpay_fail () {
		$this->_fail('zpay');
	}
	
 	function sms_ok () {
		$this->_ok ('sms');
	}
	
	function sms_fail () {
		$this->_fail('sms');
	}

	
 	function checkout_ok () {
		$this->_ok ('checkout');
	}
	
	function checkout_wait () {
		$this->lib_view->show ('checkout_wait','    ',array(),'checkout_wait');
	}

	
}


?>